## TurnGen: a household chores turn generator
## Copyright (C) 2006 Angelo "Encelo" Theodorou
##

import pygtk
pygtk.require('2.0')
import gtk.glade

class Table_Window:
	"""Create the table window"""
	def __init__(self, glade_file, db, table):
		self.glade_file = glade_file
		self.db = db
		self.table = table
		
		self.xml = gtk.glade.XML(glade_file, root="table_win")
		
		# Getting widgets
		self.table_win = self.xml.get_widget("table_win")
		self.table_list = self.xml.get_widget("table_list")

		# Setting initial attributes
		self.table_win.set_title(_('Table ') + self.table)
		self.table_win.resize(200, 200)

		# Init Methods
		self.setup_table_list()
		self.update_table_list()
		
		return


	def setup_table_list(self):
		"""Setup either a users or an activities table"""
		self.cell = gtk.CellRendererText()

		# Columns
		self.column = gtk.TreeViewColumn(_('Id'))
		self.column.pack_start(self.cell, True)
		self.column.add_attribute(self.cell, 'text', 0)
		self.column.set_resizable(True)
		self.column.set_sort_column_id(0)
		self.table_list.append_column(self.column)
	
		if self.table == 'users':
			name = _('Users')
		elif self.table == 'activities':
			name = _('Activities')

		self.column = gtk.TreeViewColumn(name)
		self.column.pack_start(self.cell, True)
		self.column.add_attribute(self.cell, 'text', 1)
		self.column.set_resizable(True)
		self.column.set_sort_column_id(1)
		self.table_list.append_column(self.column)

		# Model
		self.liststore = gtk.ListStore(int, str)
		self.table_list.set_model(self.liststore)


	def update_table_list(self):
		"""Update the table list"""

		data = self.db.fetch_table(self.table)
		for row in data:
			self.liststore.append([row[0], row[1]])
